//////////////////////////////////////////////////
//		dxv(16f873)	ThExl3.c		//
//		[ĝ						//
//		|SO`XO܂Ōv				//
//////////////////////////////////////////////////

/////////			n[hEGAp[^
#include	<16f873.h>
#device	adc=10					// A/D 10bitEl
#fuses	XT,NOWDT,PUT,BROWNOUT,NOLVP
#use	DELAY(clock=4000000)
#use	RS232(BAUD=9600,XMIT=PIN_C6,RCV=PIN_C7)
#byte	PA=5					// portA
#byte	PC=7					// portC

/////////			}N
#define	RXMAX		24			// őM
#define	CHADJMAX	1200		// CH␳ől
#define	CHADJMIN	800			// CH␳ŏl
#define	CHADJINI	1000		// CH␳Wl
#define	VREF		2.50		// d

/////////			ϐ`
short	int	RXEND;				// MtO
static	char	rxd[RXMAX+2];	// MR}hobt@
static	int	rxp;				// M|C^
signed	long	EROM[4];		// EEPROMǂݏoobt@
signed	long	TEMP[4];		// vxi~10j

/////////			bot̏
void	init(void){
	int i;
	set_tris_a(0xff);					// all input
	set_tris_b(0x00);					// all output
	set_tris_c(0x80);					// RC7 input
	setup_adc_ports(3);					// RA3 = REF,RA0,1,2,4 analog
	setup_adc(ADC_CLOCK_DIV_8);			// ADC CLOCK 2uS
	for(i=0;i<RXMAX;i++)rxd[i]=' ';		// Mobt@
}

/////////			EEPROM ̓ǂݏo
//					߂lFǂ񂾒lAF[hAhX
signed	long	rrom(int addr){
	int l,h;
	long ret;
	int sflg=0;						// tO

	l=READ_EEPROM(addr*2);			// ʓǂݏo
	h=READ_EEPROM(addr*2+1);		// ʓǂݏo
	if(h & 0x80){					// rbg
		h = h & 0x7f;				// UrbgNA
		sflg=1;						// tO𗧂Ă
	}
	ret = (long)h;
	ret = (ret << 8) | l;			// 16rbgɍ
	if(sflg) ret = -ret;			// ߂
	return	ret;
}

/////////			EEPROM ̏
//					F[hAhXAޒl
//	jΒl{rbgނ̂Œl͈̔͂́}32767
void	wrom(int addr,signed long data){
	int l,h;
	int sflg=0;							// tO

	if(data<0){							// ̎
		data = -data;					// Βl
		sflg = 1;						// tO𗧂Ă
	}
	l = (int)data;						// 
	h = (int)((data >> 8) & 0x007f);	// 
	if(sflg)h = h | 0x80;				// rbgt
	WRITE_EEPROM(addr*2,l);				// ʏ
	WRITE_EEPROM(addr*2+1,h);			// 
}

/////////			f[^̓ǂݍ݂ƃ`FbN
void	data_chk(void){
	int i;
	signed	long	temp;

	for(i=0;i<4;i++){								// CH␳l
		temp = rrom(i);								// ǂݏo
		if(temp < CHADJMIN || temp > CHADJMAX){		// ͈͊OȂ
			EROM[i]=CHADJINI;						// obt@l
			wrom(i,CHADJINI);						// EEROM
		}
		else EROM[i]=temp;							// ͈͓Ȃǂ񂾒l
	}
}

/////////			`^cϊ
void	adconv(void){
	int	i,j,ch;
	long	buf;
	signed	long	aa,bb;	// PO{̌W
	float	volt,tt;

	for(j=0;j<4;j++){
		if(j==3)ch=4;						// CH3VREF̈
		else	ch=j;
		buf=0;
		for(i=0;i<10;i++){					// 10A/D
			set_adc_channel(ch);
			delay_us(100);
			buf += read_adc();				// 10Z
		}
		buf = buf/10;						// ϒl
		if(buf%10 >4)buf = buf +1;			// ľܓ

		// xϊe[u
		if(buf > 0x373){							// |QOȉ
			aa = -972;
			bb = 1905;
		}
		else{
			if(buf <= 0x373 && buf > 0x2e4){		// |QO`O
				aa = -570;
				bb = 1036;
			}
			else{
				if(buf <= 0x2e4 && buf > 0x1d3){		// O`RO
					aa = -446;
					bb = 809;
				}
				else{
					if(buf <= 0x1d3 && buf > 0x136){		// RO`TO
						aa = -522;
						bb = 892;
					}
					else{
						if(buf <= 0x136 && buf > 0xc7){		// TO`VO
							aa = -733;
							bb = 1051;
						}
						else{
							if(buf <= 0xc7){				// VO`XO
								aa= -1132;
								bb = 1245;
							}
							else	return;
						}
					}
				}
			}
		}
		volt = VREF*(float)buf/1024.0;		// d
		volt = 1000.0*volt/(float)EROM[j];	// ␳
		tt = volt*(float)aa + (float)bb;	// xϊiPO{j
		TEMP[j] = (signed	long)tt;		// ŕۑ
	}
}

/////////			xf[^PM
//					Fxf[^iPO{̒lj
void	tx_data(signed long tt){
	int	n1,n2,n3;
	int	sflg =0;					// tO

	if(tt < 0){						// ̎
		tt = -tt;					// ΒlƂ
		sflg = 1;					// tO𗧂Ă
	}
	n1=tt / 100;					// 100̈
	tt=tt % 100;
	n2=tt / 10;						// 10̈
	n3=tt % 10;						// 1̈
	if(n1==0 && n2==0 && n3==0){	// f[^O̎
		putc(' ');
		putc(' ');
		putc(' ');
		putc('0');
	}
	else{
		if(n1==0 && n2==0){			// P̎
			putc(' ');
			putc(' ');
			if(sflg)putc('-');
			else putc(' ');
			putc(n3+0x30);
		}
		else{						// Q̎
			if(n1==0){
				putc(' ');
				if(sflg)putc('-');
				else putc(' ');
				putc(n2+0x30);
				putc(n3+0x30);
			}
			else{					// R̎
				if(sflg)putc('-');
				else putc(' ');
				putc(n1+0x30);
				putc(n2+0x30);
				putc(n3+0x30);
			}
		}
	}
}

/////////			qnlf[^PM
//					Fqnlf[^
void	tx_rom(unsigned long rr){
	int	n1,n2,n3,n4;

	n1=rr / 1000;					// 1000̈
	rr=rr % 1000;
	n2=rr / 100;					// 100̈
	rr=rr % 100;
	n3=rr / 10;						// 10̈
	n4=rr % 10;						// 1̈
	
	if(n1)	putc(n1+0x30);
	else	putc(' ');
	if(n1 || n2)	putc(n2+0x30);
	else	putc(' ');
	if(n1 || n2 || n3)	putc(n3+0x30);
	else	putc(' ');
	putc(n4+0x30);
}

/////////			MR}h̃`FbN
void	rem_mod(void){
	char	string[6];
	int	i,j;
	int n1,n2,n3,n4;
	unsigned long buff;
	int errflg;

	errflg = 0;								// f[^G[tONA
	if(RXEND){								// M
		strcpy(string,"DATA\r");			// riŏɃf[^M`FbNj
		for(i=0;i<5;i++){
			if(string[i] !=rxd[i]){			// eႤ
				goto	next1;
			}
		}
		for(i=0;i<4;i++){
			tx_data(TEMP[i]);				// xf[^𑗐M
		}
		putc('\r');							// IR[h
		for(j=0;j<RXMAX;j++)rxd[j]=' ';		// Mobt@
		rxp=0;								// M|C^NA
		RXEND=0;							// MtONA
		return;
next1:
		strcpy(string,"RROM\r");			// riqnlǎ悩`FbNj
		for(i=0;i<5;i++){
			if(string[i] !=rxd[i]){			// eႤ
				goto	next2;
			}
		}
		for (i=0;i<4;i++){
			tx_rom(EROM[i]);				// ݂̕␳l𑗐M
		}
		putc('\r');							// IR[h
		for(j=0;j<RXMAX;j++)rxd[j]=' ';		// Mobt@
		rxp=0;								// M|C^NA
		RXEND=0;							// MtONA
		return;
next2:
		strcpy(string,"WROM");				// riqnl`FbNj
		for(i=0;i<4;i++){
			if(string[i] !=rxd[i]){					// eႤ
				for(j=0;j<RXMAX;j++)rxd[j]=' ';		// Mobt@
				rxp=0;								// M|C^NA
				RXEND=0;							// MtONA
				return;
			}
		}
		for(i=0;i<4;i++){			// M񂩂珑l
			n1 = rxd[i*4 + 4] - '0';
			n2 = rxd[i*4 + 5] - '0';
			n3 = rxd[i*4 + 6] - '0';
			n4 = rxd[i*4 + 7] - '0';

			buff = (long)n1*1000 + (long)n2*100 + (long)n3*10 + (long)n4;
			if(buff < CHADJMIN || buff > CHADJMAX)errflg =1;	// ͈͊OG[tO𗧂Ă
			else {
				EROM[i] = buff;		// obt@
				wrom(i,buff);		// qnl
				delay_ms(20);
			}
		}
		if(errflg){
			putc('N');
			putc('G');
		}
		else{
			putc('O');
			putc('K');
		}
		putc('\r');
		
		for(j=0;j<RXMAX;j++)rxd[j]=' ';		// Mobt@
		rxp=0;								// M|C^NA
		RXEND=0;							// MtONA
		return;
	}
}

/////////			CvZX
void	main(void){
	init();				// bot
	data_chk();			// f[^`FbN
	rxp=0;	
	RXEND=0;
	enable_interrupts(INT_RDA);			// M荞݉
	enable_interrupts(GLOBAL);			// S荞݉
	while(1){
		adconv();		// `^cϊ
		rem_mod();		// [g[h
	}
}

/////////			qrQRQbM荞
#INT_RDA
rda_isr(){
	char	c;

	c = getc();
	if(! RXEND){				// M͎MȂiobt@󂷂̂Łj
		rxd[rxp] = c;			// MWX^̓eobt@ɓǂݎ
		if(rxd[rxp] == '\r'){	// IR[h
			RXEND=1;			// M
		}
		rxp++;					// |C^i߂		
		if(RXMAX < rxp)rxp = 0;	// őM
	}
}

